#include "configfile.h"
#include <gtk/gtk.h> 
#include <string.h>

#include "pixmaps/boy.xpm"
#include "pixmaps/girl.xpm"
#include "pixmaps/zu_open.xpm"
#include "pixmaps/zu_close.xpm"
#include "pixmaps/yqfile_open.xpm"
#include "pixmaps/yqfile_close.xpm"
#include "pixmaps/laji.xpm"

extern GtkWidget *nb_1_1,*nb_1_2,*nb_1_3,*nb_1_4,*nb_1_5,*nb_1_6,*nb_1_7,*nb_1_8,*nb_1_9,*nb_1_10,*nb_1_11,*nb_1_12,*nb_1_13,*nb_2_1,*nb_2_2,*nb_2_3,*nb_2_4,*nb_2_5,*nb_2_6,*nb_2_7,*nb_2_8,*nb_2_9,*nb_2_10,*nb_3_1,*nb_3_2,*nb_3_3,*nb_3_4;

extern GtkWidget *tree_main;
extern ConfigFile *cfgfile;

GtkWidget *yq_readzu(gchar zu[256]);
GtkWidget *CreateWidgetFromXpm (GtkWidget *parent,gchar **xpm_data);
void leaf_selected (GtkWidget *widget, gchar *jilu);
void zu_selected (GtkWidget *widget, gchar *zu);
void tree_set_pixmap(GtkWidget *parent,GtkTreeItem *treeitem, gint ed);
void zu_expanded(GtkWidget *widget, gchar *zu);
void zu_collapsed(GtkWidget *widget, gchar *zu);
void yqfile_expanded(GtkWidget *widget, gchar *zu);
void yqfile_collapsed(GtkWidget *widget, gchar *zu);
void leaf_setnb_settext(gint a,gint b,gchar *ab);
void leaf_setnb(gchar *ab);
gchar *leaf_formattext(gchar *bd);


void 
tree_set_pixmap(GtkWidget *parent,GtkTreeItem *treeitem, gint ed)
{
	static GdkPixmap *yqfile_open, *yqfile_close,*zu_open,*zu_close;
	static GdkBitmap *mask_yo,*mask_yc,*mask_zo,*mask_zc;
	static GtkStyle *style;
	
	GtkPixmap *hbox, *pixmap;
	
	if (yqfile_open == NULL || yqfile_close == NULL || zu_open==NULL || zu_close==NULL)
	{
                style = gtk_widget_get_style(parent);  
		yqfile_open = gdk_pixmap_create_from_xpm_d(
			parent->window,
			&mask_yo,&style->bg[GTK_STATE_NORMAL] ,
			(gchar **)yqfile_open_xpm
		);
		yqfile_close = gdk_pixmap_create_from_xpm_d(
			parent->window,
			&mask_yc, &style->bg[GTK_STATE_NORMAL],
			(gchar **)yqfile_close_xpm
		);
		zu_open = gdk_pixmap_create_from_xpm_d(
			parent->window,
			&mask_zo, &style->bg[GTK_STATE_NORMAL],
			(gchar **)zu_open_xpm
		);
		zu_close = gdk_pixmap_create_from_xpm_d(
			parent->window,
			&mask_zc, &style->bg[GTK_STATE_NORMAL],
			(gchar **)zu_close_xpm
		);

	}
	
	hbox = gtk_container_children(GTK_CONTAINER(treeitem))->data;
	pixmap = gtk_container_children(GTK_CONTAINER(hbox))->data;
	switch(ed)
	{
	case 1:
             gtk_pixmap_set(GTK_PIXMAP(pixmap), yqfile_open, mask_yo);     
	     break; 
	case 2:
             gtk_pixmap_set(GTK_PIXMAP(pixmap), yqfile_close, mask_yc);     
	     break;	          
        case 3:
             gtk_pixmap_set(GTK_PIXMAP(pixmap), zu_open, mask_zo);     
	     break;	  
	case 4:
	     gtk_pixmap_set(GTK_PIXMAP(pixmap), zu_close, mask_zc);     
	     break;        
	}
	     
}

void
leaf_selected (GtkWidget *widget, gchar *jilu)
{  
    gchar zu[260],*ti,*ab;
    
    strcpy(zu,jilu);
    ti= strchr(zu,'-'); 
    *ti='\0';
    ti++;
    x11amp_cfg_read_string(cfgfile,zu,ti,&ab);
    leaf_setnb(ab);
}
gchar 
*leaf_formattext(gchar *bd)
{
  gchar *ab,*tm,*bb;
  gint i;
  i=strlen(bd)+1;
  bb=g_malloc(i);
  strcpy(bb,bd);
  ab=g_malloc(i);
  tm=ab;
  while (*bb!='\0')
     {
     if (*bb!='/') 
          {
            *ab=*bb;
            ab++;
            bb++;
           }
      else
         {
         bb++;
         switch (*bb)
           {
           case '/':
             {*ab='/';break;}
           case 'n':
             { *ab='\n';break;}
           case 'd':
             { *ab=',';break;}  
           }
          ab++;
          bb++;     
         }      
     }
  *ab='\0'; 
  ab=tm;
  return ab;
}

void
leaf_setnb_settext(gint a,gint b,gchar *bd)
{
  gchar *ab;
  ab=leaf_formattext(bd);
  switch (a)
  {
    case 1:
        switch (b)
         {
           case 1: gtk_entry_set_text(GTK_ENTRY(nb_1_1),ab);break;
           case 2: gtk_entry_set_text(GTK_ENTRY(nb_1_2),ab);break;
           case 3: gtk_entry_set_text(GTK_ENTRY(nb_1_3),ab);break;
           case 4: 
           if (*ab=='1')
           gtk_entry_set_text (GTK_ENTRY (GTK_COMBO(nb_1_4)->entry),"");
           else gtk_entry_set_text (GTK_ENTRY (GTK_COMBO(nb_1_4)->entry), "Ů");
                break;
           case 5: 
           if (*ab=='1')
           gtk_entry_set_text (GTK_ENTRY (GTK_COMBO(nb_1_5)->entry), "");
           else gtk_entry_set_text (GTK_ENTRY (GTK_COMBO(nb_1_5)->entry), "");
                break;
           case 6: 
           if (*ab=='1')
          gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON(nb_1_6), 1);
           else gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON(nb_1_6), 0); 
                break;
           case 7: gtk_entry_set_text(GTK_ENTRY(nb_1_7),ab);break;
           case 8: gtk_entry_set_text(GTK_ENTRY(nb_1_8),ab);break;
           case 9: gtk_entry_set_text(GTK_ENTRY(nb_1_9),ab);break;
           case 10: gtk_entry_set_text(GTK_ENTRY(nb_1_10),ab);break;
           case 11: gtk_entry_set_text(GTK_ENTRY(nb_1_11),ab);break;
           case 12: gtk_entry_set_text(GTK_ENTRY(nb_1_12),ab);break;
           case 13: gtk_entry_set_text(GTK_ENTRY(nb_1_13),ab);break;   
         }
         break;
    case 2:
        switch (b)
         {
           case 1: gtk_entry_set_text(GTK_ENTRY(nb_2_1),ab);break;
           case 2: gtk_entry_set_text(GTK_ENTRY(nb_2_2),ab);break;
           case 3: gtk_entry_set_text(GTK_ENTRY(nb_2_3),ab);break;
           case 4: gtk_entry_set_text(GTK_ENTRY(nb_2_4),ab);break;
           case 5: gtk_entry_set_text(GTK_ENTRY(nb_2_5),ab);break;
           case 6: gtk_entry_set_text(GTK_ENTRY(nb_2_6),ab);break;
           case 7: gtk_entry_set_text(GTK_ENTRY(nb_2_7),ab);break;
           case 8: gtk_entry_set_text(GTK_ENTRY(nb_2_8),ab);break;
           case 9: gtk_entry_set_text(GTK_ENTRY(nb_2_9),ab);break;
           case 10: gtk_entry_set_text(GTK_ENTRY(nb_2_10),ab);break;
           
         }
         break;
    case 3:
        switch (b)
         {
           case 1: gtk_entry_set_text(GTK_ENTRY(nb_3_1),ab);break;
           case 2: gtk_entry_set_text(GTK_ENTRY(nb_3_2),ab);break;
           case 3: 
               gtk_text_freeze (GTK_TEXT (nb_3_3));
               gtk_editable_delete_text (GTK_EDITABLE (nb_3_3), 0, -1);
               gtk_text_insert (GTK_TEXT (nb_3_3), NULL, NULL,
                   NULL, ab, strlen(ab));
               gtk_text_thaw (GTK_TEXT (nb_3_3));
               break;
           case 4:
               gtk_text_freeze (GTK_TEXT (nb_3_4));
               gtk_editable_delete_text (GTK_EDITABLE (nb_3_4), 0, -1);
               gtk_text_insert (GTK_TEXT (nb_3_4), NULL, NULL,
                   NULL, ab, strlen(ab));
               gtk_text_thaw (GTK_TEXT (nb_3_4));
               break;
         }
         break;         
  }
}
void
leaf_setnb(gchar *ab)
{
    gchar *jilu,*as;
    gint i,j,k;
    jilu=g_malloc(strlen(ab)+1);
    strcpy(jilu,ab);
    for (i=1;i<=3;i++)
     {
       switch (i)
        {
         case 1: k=13;break;
         case 2: k=10;break;
         case 3: k=4;break;
        }
       for (j=1;j<=k;j++)
        {
        as= strchr(jilu,','); 
        if (as)
         { 
         *as='\0';
         leaf_setnb_settext(i,j,jilu);          
         jilu=as;
         jilu++;
         }
         else leaf_setnb_settext(i,j,jilu);
        } 
     }   
}

void
zu_selected (GtkWidget *widget, gchar *zu)
{
  gchar *ab;
    x11amp_cfg_read_string(cfgfile,zu,"n",&ab);
    g_print ("zu:%s\n",ab);   
}
void
yqfile_expanded(GtkWidget *widget, gchar *zu)
{
    tree_set_pixmap(tree_main,GTK_TREE_ITEM(widget),1);
}

void
yqfile_collapsed(GtkWidget *widget, gchar *zu)
{
    tree_set_pixmap(tree_main,GTK_TREE_ITEM(widget),2);
}

void
zu_expanded(GtkWidget *widget, gchar *zu)
{
    tree_set_pixmap(tree_main,GTK_TREE_ITEM(widget),3);
}

void
zu_collapsed(GtkWidget *widget, gchar *zu)
{
    tree_set_pixmap(tree_main,GTK_TREE_ITEM(widget),4);
}


GtkWidget* 
yq_readzu(gchar zu[256])
{
GtkWidget *tree,*leaf,*hbox,*label;
gchar *ab,*bb,ti[4],*zz,tz[260];
gint i,z;
          tree=gtk_tree_new();
          gtk_widget_show (tree);
          x11amp_cfg_read_int(cfgfile,zu,"z",&z);
          
          for (i=1;i<=z;i++)
          {
           sprintf(tz,"%s_%d",zu,i);
           zz=g_malloc(strlen(tz)+1);
           strcpy(zz,tz);
           x11amp_cfg_read_string(cfgfile,zz,"n",&ab);
           leaf = gtk_tree_item_new();
           gtk_widget_show(leaf);
	   hbox = gtk_hbox_new(FALSE, 1);
	   gtk_widget_show(hbox);
           gtk_box_pack_start(GTK_BOX(hbox), CreateWidgetFromXpm (tree,(gchar **) zu_close_xpm), FALSE, FALSE, 0);
	   label = gtk_label_new(ab);
	   gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
           gtk_widget_show(label);
	   gtk_container_add(GTK_CONTAINER(leaf), hbox);
			
           gtk_signal_connect(GTK_OBJECT(leaf), "expand",
				GTK_SIGNAL_FUNC(zu_expanded), zz);
           gtk_signal_connect(GTK_OBJECT(leaf), "collapse",
				GTK_SIGNAL_FUNC(zu_collapsed), zz);
           gtk_signal_connect(GTK_OBJECT(leaf), "select",
			GTK_SIGNAL_FUNC(zu_selected),zz);


           gtk_tree_append(GTK_TREE(tree),leaf);
           gtk_tree_item_set_subtree(GTK_TREE_ITEM(leaf),yq_readzu(zz));
          } 
          
          
          x11amp_cfg_read_int(cfgfile,zu,"a",&z);
          for (i=1;i<=z;i++)
          {           
           sprintf(ti,"%d",i);
           sprintf(tz,"%s-%s",zu,ti);
          zz=g_malloc(strlen(tz)+1);
          strcpy(zz,tz);
          x11amp_cfg_read_string(cfgfile,zu,ti,&ab);
  	bb=strchr(ab,',');
  	*bb='\0';
	leaf = gtk_tree_item_new();
	hbox = gtk_hbox_new(FALSE, 1);
	gtk_widget_show(leaf);
	gtk_widget_show(hbox);
	
	gtk_box_pack_start(GTK_BOX(hbox), CreateWidgetFromXpm (hbox,(gchar **) boy_xpm), FALSE, FALSE, 0);
	label = gtk_label_new(leaf_formattext(ab));
	*bb=',';
	gtk_widget_show(label);
        gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
	gtk_container_add(GTK_CONTAINER(leaf), hbox);		
 	gtk_signal_connect(GTK_OBJECT(leaf), "select",
			GTK_SIGNAL_FUNC(leaf_selected),zz);

        gtk_tree_append(GTK_TREE(tree),leaf);
          }           
          return tree;
}

GtkWidget* 
yq_readfile(gchar *open_file)
{
	GtkWidget *leaf,*hbox,*label;
	gchar *ab;
                       
        cfgfile=x11amp_cfg_open_file(open_file);
        if(cfgfile)
        {
         x11amp_cfg_read_string(cfgfile,"yq","n",&ab);

        leaf = gtk_tree_item_new();
	hbox = gtk_hbox_new(FALSE, 1);
	gtk_widget_show(leaf);
	gtk_widget_show(hbox);
	
	gtk_box_pack_start(GTK_BOX(hbox), CreateWidgetFromXpm (tree_main,(gchar **) yqfile_close_xpm), FALSE, FALSE, 0);
	label = gtk_label_new(ab);
	gtk_widget_show(label);
        gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
	gtk_container_add(GTK_CONTAINER(leaf), hbox);
	gtk_signal_connect(GTK_OBJECT(leaf), "expand",
				GTK_SIGNAL_FUNC(yqfile_expanded),"yq");
        gtk_signal_connect(GTK_OBJECT(leaf), "collapse",
				GTK_SIGNAL_FUNC(yqfile_collapsed),"yq");		
         gtk_tree_append(GTK_TREE(tree_main),leaf);
         gtk_tree_item_set_subtree(GTK_TREE_ITEM(leaf),yq_readzu("yq"));
         return leaf;
        }         
}
